Description

Orangutan can be very helpful for employees which use SVN...

What is required for a user to track time? A user must specify work hours, project and maybe issue and a short description...

What does developer which uses SVN do? Runs “update” when comes to the office and runs “commit” when leaves... If we assume
that a user always specifies a description when committing (-m) we have a start time, end time and a description! All that we need is
project/issue - project can be guessed (or determined if SVN was registered in Redmine) and issue can be extracted from -m
message...

That is:

)

When user does “update” Orangutan starts “tracking”;

When user goes away and returns Orangutan tracks breaks and saves them somewhere;
When user commits...

¢ Orangutan tries to determine the project (if failed the monkey can ask for project later);
Orangutan tries to determine the issue;

e Orangutan suggests a user to save tasks...

The last is done when there are no conflicts - that is a user did not save any entries for the time a user is believed to work.

That is a user will only be required to answer “yes” per commit (besides the cases when the project is not known)...

Related issues:
Related to Orangutan - Enhancement #158: Extend architecture to support exter... Closed 18 Jun 2010 20 Jun 2010

History

#1 - 29 Jun 2010 18:07 - Andriy Lesyuk

The algorithm above was described very shortly. Of course, in reality it will be much more complicated. For example:

e |t will ignore updates between the first update and commit (because it is recommended to always update before commit);
® The first update will be usually a morning update;
L]
L]

The algorithm can be also changed to treat commit as a start of the task if it (commit) was done at the middle of a working day;
etc.

#2 - 08 Nov 2010 16:46 - Andriy Lesyuk

- Status changed from Open to Incomplete
Not sure if anyone needs this...

#3 - 03 Mar 2011 00:38 - Andriy Lesyuk

- Status changed from Incomplete to Open
